<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 3.2//EN">
<HTML>
<HEAD>
<Title> Tango Device Server User's Guide </Title>
</HEAD>
<BODY TEXT="#000000" BGCOLOR="#FFFFFF" LINK="#0000FF" VLINK="#7F00FF" ALINK="#FF0000">

<P><!-------TITLE------></P>
<TABLE BORDER="0" WIDTH="100%">
    <TR>
        <TD ALIGN="left">
			<A HREF="http://www.esrf.fr/" TARGET=new>
			<IMG SRC="http://www.esrf.fr/gifs/logo/80.gif" BORDER=0 Height="60"></A>
		</Td>
        <TD ALIGN="center">
			<A HREF="http://www.elettra.trieste.it/" TARGET=new>
			<IMG SRC="http://www.esrf.fr/computing/cs/tango/elettra_logo.gif" BORDER=0 Height="60"></A>

		</Td>
        <TD ALIGN="center">
			<A HREF="http://www.synchrotron-soleil.fr/" TARGET=new>
			<IMG SRC="http://www.esrf.fr/computing/cs/tango/soleil_logo.gif" BORDER=0 Height="60"></A>
		</Td>
        <TD ALIGN="right">
			<A HREF="http://www.cells.es/" TARGET=new>
			<IMG SRC="http://www.esrf.fr/computing/cs/tango/alba.jpg" BORDER=0 Height="54"></A>
		</Td>
        <TD ALIGN="right">
			<A HREF="http://www.desy.de/html/home/index_eng.html" TARGET=new>
			<IMG SRC="http://www.esrf.fr/computing/cs/tango/desy.gif" BORDER=0 Height="60"></A>
		</Td>
    	 <Td>
			<H2><FONT COLOR="#7F00FF">
			<Center><A HREF="http://www.tango-controls.org/" TARGET="_top">
					 TANGO </a> <Br> Device Server
			</Center></FONT>
		</Td>
    </TR>
</TABLE>

<HR WIDTH="100%"></H5>

<Br>&nbsp;<Br><Br>&nbsp;<Br><Br>&nbsp;<Br><center><Table Border=2 Cellpadding=3 CELLSPACING=0 WIDTH="100%">
<Tr><Td><Br>&nbsp;<Br>
<center>
<h1>
Keithley multimeters device <Br>
User's Guide<Br>&nbsp;<Br> <Br><Br>
KeithleyMultimeters Class<Br>&nbsp;<Br></Td></Tr>
</h1>
<Tr><Td>
<b><Center>Revision:  - Author:  <Br>
 Implemented in C++
</Center></b>
</Td></Tr>
</center>
</Table>
</center>
<Br>
<Br>
<Br>
<Br>
<Br>&nbsp;<Br><Br>&nbsp;<Br>
<h2>Introduction:</h2>
<ul>
	Device to interface a Keithley multimeters 2701. <br>
The Keithley is configured in Voltmeter <br>
The ReadBufferedData command initiate a scan and <br>
readback data stored in the Keithley buffer up to 450000 points. <br>
nbPoins and nPLC attributes are INVALID in RUNNING state (while Keithley integrates).<Br>
</ul>
<Br>
<Br>
<Br><h2>Class Identification:</h2>
<ul>
	<li><b>Contact      :</b>	 at synchrotron-soleil.fr - xavier.elattaoui
	<li><b>Class Family :</b>	Instrumentation
	<li><b>Platform     :</b>	All Platforms
	<li><b>Bus          :</b>	GPIB
	<li><b>Manufacturer :</b>	Keithley
	<li><b>Reference    :</b>	2700
</ul><Br>&nbsp;<Br><Br>
<h2>Class Inheritance:</h2>
	<ul>
		<li> <a href="http://www.esrf.fr/computing/cs/tango/tango_doc/kernel_doc/cpp_doc/"> Tango::Device_4Impl</a></li>
		<ul>
			<li> KeithleyMultimeters</li>
			</ul>
		</ul>
	</ul>
</ul>
<Br>&nbsp;<Br>
<h2>Description:</h2>

</b>
</center>


<Center>
Device to interface a Keithley multimeters.
<Br>
<Br>
</Center>


</center>
<Br>&nbsp;<Br><Br>&nbsp;<Br><h2>Properties:</h2>


<Center>
<Br> <Br> <Br> 
<Table Border=2 Cellpadding=3 CELLSPACING=0 WIDTH="100%">
<TR BGCOLOR="#CCCCFF" CLASS="TableHeadingColor">
<Td COLSPAN=3> <Font Size=+2><Center><b>Device Properties</b></td></Font></Center>
<TR BGCOLOR="#CCCCFF" CLASS="TableHeadingColor">
<Td><Center><b>Property name</b></td></Center>
<Td><Center><b>Property type</b></td></Center>
<Td><Center><b>Description</b></td></Center>
<Tr><Td><b><a href=#Dev_DefaultValues>CommunicationLinkName </a></b></Td>
<Td><Font Size=-1>std::string</Font></Td>
<Td><Font Size=-1>Name of the device proxy which handles the communciation.</Font></Td></Tr>

</Table>

</Center>
<Br><Br><Br>
<Br><Br><Br>

<A name=Dev_DefaultValues><!---  ---></a>
<Font Size=+1>Device Properties Default Values:</Font><Br>
<Table Border=2 Cellpadding=2 CELLSPACING=2>
    <tr BGCOLOR="#CCCCFF" CLASS="TableHeadingColor">
        <Td><b>Property Name</b></td>
        <td><b>Default Values</b></td>
    </Tr>
    <Tr>
        <Td>CommunicationLinkName</Td>
        <td>no/proxy/defined</td>
    </Tr>
</Table>

<Br><Br><Br>
<Center><b>
There is no Class properties.<Br><Br>
</Center></b>
<Br> <Br> <Br> 


</center>
<Br>&nbsp;<Br><Br>&nbsp;<Br><h2>States:</h2>


<Center>
<Br> <Br> <Br> 
<Table Border=2 Cellpadding=3 CELLSPACING=0 WIDTH="100%">
<TR BGCOLOR="#CCCCFF" CLASS="TableHeadingColor">
<Td COLSPAN=2> <Font Size=+2><Center><b>States</b></td></Font></Center>
<TR BGCOLOR="#CCCCFF" CLASS="TableHeadingColor">
<Td><Center><b>Names</b></td></Center>
<Td><Center><b>Descriptions</b></td></Center>
<Tr><Td><b>RUNNING</b></Td>
<Td><Font Size=-1>Reading Keithley buffered data.</Font></Td></Tr>

<Tr><Td><b>STANDBY</b></Td>
<Td><Font Size=-1>Ready and not acquiring.</Font></Td></Tr>

<Tr><Td><b>FAULT</b></Td>
<Td><Font Size=-1>Communication link problem or bad initialization.</Font></Td></Tr>




</Table>
</Center>


</center>
<Br>&nbsp;<Br><Br>&nbsp;<Br><h2>Attributes:</h2>


<Br>
<Table Border=2 Cellpadding=3 CELLSPACING=0 WIDTH="100%">
<TR BGCOLOR="#CCCCFF" CLASS="TableHeadingColor">
<Td COLSPAN=4> <Font Size=+2><Center><b>Scalar Attributes</b></td></Font></Center>
<TR BGCOLOR="#CCCCFF" CLASS="TableHeadingColor">
<Td><Center><b>Attribute name</b></td></Center>
<Td><Center><b>Data Type</b></td></Center>
<Td><Center><b>R/W Type</b></td></Center>
<Td><Center><b>Expert</b></td></Center>
<Tr><Td><b>nbPoints</b>: <Font Size=-1>Acquisition buffer size in the range [2,450000]</Font></Td>
<Td><Center><Font Size=-1>DEV_ULONG</Font></Center></Td><Td><Center><Font Size=-1>READ_WRITE</Font></Center></Td><Td><Center><Font Size=-1>No</Font></Center></Td></Tr>

<Tr><Td><b>bufferedPoints</b>: <Font Size=-1>Number of readings stored in buffer</Font></Td>
<Td><Center><Font Size=-1>DEV_ULONG</Font></Center></Td><Td><Center><Font Size=-1>READ</Font></Center></Td><Td><Center><Font Size=-1>No</Font></Center></Td></Tr>

<Tr><Td><b>nPLC</b>: <Font Size=-1>Integration rate in line cycles int the range [0.002,50]</Font></Td>
<Td><Center><Font Size=-1>DEV_DOUBLE</Font></Center></Td><Td><Center><Font Size=-1>READ_WRITE</Font></Center></Td><Td><Center><Font Size=-1>Yes</Font></Center></Td></Tr>

<Tr><Td><b>triggerSource</b>: <Font Size=-1>Select control source (IMMediate, TIMer, MANual, BUS or EXTernal).</Font></Td>
<Td><Center><Font Size=-1>DEV_STRING</Font></Center></Td><Td><Center><Font Size=-1>READ_WRITE</Font></Center></Td><Td><Center><Font Size=-1>Yes</Font></Center></Td></Tr>

</Table>
</Center>
<Br><Br><Br><Br><Br>
<Table Border=2 Cellpadding=3 CELLSPACING=0 WIDTH="100%">
<TR BGCOLOR="#CCCCFF" CLASS="TableHeadingColor">
<Td COLSPAN=4> <Font Size=+2><Center><b>Spectrum Attributes</b></td></Font></Center>
<TR BGCOLOR="#CCCCFF" CLASS="TableHeadingColor">
<Td><Center><b>Attribute name</b></td></Center>
<Td><Center><b>Data Type</b></td></Center>
<Td><Center><b>X Data Length</b></td></Center>
<Td><Center><b>Expert</b></td></Center>
<Tr><Td><b>dataBuffered</b>: <Font Size=-1>data from the hardware buffer</Font></Td>
<Td><Center><Font Size=-1>DEV_DOUBLE</Font></Center></Td><Td><Center><Font Size=-1>450000</Font></Center></Td><Td><Center><Font Size=-1>No</Font></Center></Td></Tr>

</Table>
</Center>
<Br><Br><Br><Br><Br>


</center>
<Br>&nbsp;<Br><Br>&nbsp;<Br><h2>Commands:</h2>


<Center>
<Br><Br>
<A Href="DevCommandsFrame.html"> More Details on commands.... </a><Br>
<Br> <Br>
<Table Border=2 Cellpadding=3 CELLSPACING=0 WIDTH="100%">
<TR BGCOLOR="#CCCCFF" CLASS="TableHeadingColor">
<Td COLSPAN=3> <Font Size=+2><Center><b>Device Commands for Operator Level</b></td></Font></Center>
<TR BGCOLOR="#CCCCFF" CLASS="TableHeadingColor">
<Td><Center><b>Command name</b></td></Center>
<Td><Center><b>Argument In</b></td></Center>
<Td><Center><b>Argument Out</b></td></Center>
<Tr><Td><b>Init</b></Td>
<Td><Font Size=-1>DEV_VOID</Font></Td>
<Td><Font Size=-1>DEV_VOID</Font></Td>
<Tr><Td><b>State</b></Td>
<Td><Font Size=-1>DEV_VOID</Font></Td>
<Td><Font Size=-1>DEV_STATE</Font></Td>
<Tr><Td><b>Status</b></Td>
<Td><Font Size=-1>DEV_VOID</Font></Td>
<Td><Font Size=-1>CONST_DEV_STRING</Font></Td>
<Tr><Td><b>ReadBufferedData</b></Td>
<Td><Font Size=-1>DEV_VOID</Font></Td>
<Td><Font Size=-1>DEV_VOID</Font></Td>



</Table></Center>
<Br> <Br> <Br> 
<Center>
<Table Border=2 Cellpadding=3 CELLSPACING=0 WIDTH="100%">
<TR BGCOLOR="#CCCCFF" CLASS="TableHeadingColor">
<Td COLSPAN=3> <Font Size=+2><Center><b>Device Commands for Expert Level Only</b></td></Font></Center>
<TR BGCOLOR="#CCCCFF" CLASS="TableHeadingColor">
<Td><Center><b>Command name</b></td></Center>
<Td><Center><b>Argument In</b></td></Center>
<Td><Center><b>Argument Out</b></td></Center>
<Tr><Td><b>WriteRead</b></Td>
<Td><Font Size=-1>DEV_STRING</Font></Td>
<Td><Font Size=-1>DEV_STRING</Font></Td>
<Tr><Td><b>Abort</b></Td>
<Td><Font Size=-1>DEV_VOID</Font></Td>
<Td><Font Size=-1>DEV_VOID</Font></Td>



</Table></Center>

</center>
<Br>&nbsp;<Br>

<Br>
<Br>
<Br>
<A NAME="Init"><!-- --></A>
<A NAME="Init"><!-- --></A>
<h2>1 - Init</h2>
<ul>
<Li><Strong>Description: </Strong> This commands re-initialise a device keeping the same network connection.<Br>
After an Init command executed on a device, it is not necessary for client to re-connect to the device.<Br>
This command first calls the device <i> delete_device() </i>method and then execute its <i> init_device()</i> method.<Br>
For C++ device server, all the memory allocated in the <i> nit_device() </i> method must be freed in the <i> delete_device() </i> method.<Br>
The language device desctructor automatically calls the <i> delete_device() </i> method.<Br>&nbsp
<Li><Strong>Argin:<Br>DEV_VOID</Strong>
 : none.<Br>&nbsp
<Li><Strong>Argout:<Br>DEV_VOID</Strong>
 : none.<Br>&nbsp
<Li><Strong>Command allowed for: </Strong><Ul>
<Li>Tango::RUNNING<Li>Tango::STANDBY<Li>Tango::FAULT</Ul>
<Br>&nbsp
</ul><Br>
<Br>
<A NAME="State"><!-- --></A>
<A NAME="State"><!-- --></A>
<h2>2 - State</h2>
<ul>
<Li><Strong>Description: </Strong> This command gets the device state (stored in its <i>device_state</i> data member) and returns it to the caller.<Br>&nbsp
<Li><Strong>Argin:<Br>DEV_VOID</Strong>
 : none.<Br>&nbsp
<Li><Strong>Argout:<Br>DEV_STATE</Strong>
 : State Code<Br>&nbsp
<Li><Strong>Command allowed for: </Strong><Ul>
<Li>Tango::RUNNING<Li>Tango::STANDBY<Li>Tango::FAULT</Ul>
<Br>&nbsp
</ul><Br>
<Br>
<A NAME="Status"><!-- --></A>
<A NAME="Status"><!-- --></A>
<h2>3 - Status</h2>
<ul>
<Li><Strong>Description: </Strong> This command gets the device status (stored in its <i>device_status</i> data member) and returns it to the caller.<Br>&nbsp
<Li><Strong>Argin:<Br>DEV_VOID</Strong>
 : none.<Br>&nbsp
<Li><Strong>Argout:<Br>CONST_DEV_STRING</Strong>
 : Status description<Br>&nbsp
<Li><Strong>Command allowed for: </Strong><Ul>
<Li>Tango::RUNNING<Li>Tango::STANDBY<Li>Tango::FAULT</Ul>
<Br>&nbsp
</ul><Br>
<Br>
<A NAME="ReadBufferedData"><!-- --></A>
<A NAME="ReadBufferedData"><!-- --></A>
<h2>4 - ReadBufferedData</h2>
<ul>
<Li><Strong>Description: </Strong> Command to start an acquisition and to read back the Keithley stored data.<Br>&nbsp
<Li><Strong>Argin:<Br>DEV_VOID</Strong>
 : no argin<Br>&nbsp
<Li><Strong>Argout:<Br>DEV_VOID</Strong>
 : no argout<Br>&nbsp
<Li><Strong>Command allowed for: </Strong><Ul>
<Li>Tango::STANDBY</Ul>
<Br>&nbsp
</ul><Br>
<Br>
<A NAME="WriteRead"><!-- --></A>
<A NAME="WriteRead"><!-- --></A>
<h2>5 - WriteRead (for expert only)</h2>
<ul>
<Li><Strong>Description: </Strong> Send a specific Keithley command and read back response if any (low level command)<Br>&nbsp
<Li><Strong>Argin:<Br>DEV_STRING</Strong>
 : Keithley SCPI command to send<Br>&nbsp
<Li><Strong>Argout:<Br>DEV_STRING</Strong>
 : Command response<Br>&nbsp
<Li><Strong>Command allowed for: </Strong><Ul>
<Li>Tango::STANDBY<Li>Tango::FAULT</Ul>
<Br>&nbsp
</ul><Br>
<Br>
<A NAME="Abort"><!-- --></A>
<A NAME="Abort"><!-- --></A>
<h2>6 - Abort (for expert only)</h2>
<ul>
<Li><Strong>Description: </Strong> Abort acquisition and clear stored data.<Br>&nbsp
<Li><Strong>Argin:<Br>DEV_VOID</Strong>
 : no argin<Br>&nbsp
<Li><Strong>Argout:<Br>DEV_VOID</Strong>
 : no argout<Br>&nbsp
<Li><Strong>Command allowed for: </Strong><Ul>
<Li>Tango::RUNNING<Li>Tango::STANDBY<Li>Tango::FAULT</Ul>
<Br>&nbsp
</ul><Br>
<Br>

</center>
<Br>&nbsp;<Br><Br>&nbsp;<Br>

<!--- html Footer --->

<Center>
<Font size=-1>
<br>
<br>
<TABLE BORDER="1" WIDTH="100%">
    <Tr>
		<!--- Hosted by Sourceforge --->
        <Td Align="Center">
			<Font size=-1>
			<b>TANGO</b> is an open source project hosted by :<br>
			<A href="http://sourceforge.net" Target="new">
					<IMG title="Sourceforge logo"
						alt="Sourceforge logo small"
						src="http://www.esrf.fr/computing/cs/tango/sourceforge.gif"
						border=0> </a>
			</Font>
		</Td>
		<!--- 2 Sourceforge Repositories --->
		<Td Align="Center">
			<Font size=-1>
			Core and Tools :
			<a href="http://tango-cs.cvs.sourceforge.net/tango-cs/" Target="new">
			CVS repository</a> on
			<a href="https://sourceforge.net/projects/tango-cs" Target=new>
			tango-cs project</a>

			<br>

			Device Servers :
			<a href="http://tango-ds.cvs.sourceforge.net/tango-ds/" Target="new">
					CVS repository</a> on
			<a href="https://sourceforge.net/projects/tango-ds" Target=new>
					tango-ds project</a>
			</Font>
		</Td>
    </Tr>
</Table>
</Font>
</Center>
</body>
</html>
